package org.ssssssss.magicboot.controller;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.ssssssss.magicboot.fxapi.HttpClientResult;
import org.ssssssss.magicboot.fxapi.HttpClientUtils;
import org.ssssssss.magicboot.fxapi.XKTokenAccess;
import org.ssssssss.magicboot.fxapi.model.CrmFXApiParam;
import org.ssssssss.magicboot.zdyutils.FXHTTP;
import org.ssssssss.magicboot.zdyutils.GcjJson;
import org.ssssssss.magicboot.zdyutils.MagicApi;

import java.text.SimpleDateFormat;
import java.util.*;

@RestController
@RequestMapping("/group")
public class customergroupController {
    static Logger logger = LoggerFactory.getLogger("customergroup");

    public static void main(String[] args) throws Exception {
        new customergroupController().getSynData();

    }
    @PostMapping("/getSynData")
    public void getSynData() throws Exception {

        FXHTTP fxapi = new FXHTTP();
        JSONObject jsonject = fxapi.getXKName("AccountObj");
        JSONArray array = jsonject.getJSONObject("data").getJSONObject("describe").getJSONObject("fields")
                .getJSONObject("erp_category__c").getJSONArray("options");

       // SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            Boolean sendFlag = false;//是否阻断
            StringBuffer stringBuffer = new StringBuffer();

            String sendUrl = "http://192.168.31.233:8022/ierp/kapi/v2/f9w5/basedata/bd_customergroup/customergroupSave";
            String sendBody = "";
            String sendRes = "";

            String label = GcjJson.getNodeValue(str, "JSON.label") != null ? GcjJson.getNodeValue(str, "JSON.label").toString() : "";
            String value = GcjJson.getNodeValue(str, "JSON.value") != null ? GcjJson.getNodeValue(str, "JSON.value").toString() : "";


            Boolean tbflag = false;

            JSONObject ataLog = MagicApi.getDataLog("group", label);
            if (ataLog != null && label.equals(ataLog.getString("dataId"))) {
                tbflag = true;
            }
            if (tbflag) {
                System.out.println("数据已存在" + label);
                continue;
            }


           // String token = "2096108315279888384_Y8HeV0864EhPN9oPNs57p3B6tpFipZoQB6NMm1aczKr1QGotVhrr6FIpOfz4H67lNpol7NvBPXIb93t8U2UddG1SFKdXy5h78Sl502";
            String accessToken = new KDTokenController().getKDAccessTokenTest();

            if (accessToken == null || accessToken.equals("")) {
                logger.info("金蝶token为空或不存在");
                return;
            }

            Map<String, String> headers = new HashMap<String, String>();
            headers.put("accessToken",  accessToken);//放token

            JSONObject params = new JSONObject();

            JSONArray dataarr = new JSONArray();
            JSONObject datajson = new JSONObject();

            datajson.put("number",value);
            datajson.put("name",label);
            datajson.put("parent_number","K001");//上级是中国
            datajson.put("standard_number","JBFLBZ");//基本分类标准
            datajson.put("createorg_number","zyierp");//上级是中国


            dataarr.add(datajson);
            params.put("data",dataarr);
            logger.info("--请求json---" + params.toJSONString());
            System.out.println("--请求json:---" +params.toJSONString());
            sendBody = params.toJSONString();
            String erpid= "";
            try {
                HttpClientResult rtn = HttpClientUtils.doPostJson(sendUrl, headers, params.toJSONString());
                String resStr =  rtn.getContent();
                JSONObject resjs = JSONObject.parseObject(resStr);
                System.out.println(resjs);
                sendRes =  resStr;

                if (resjs != null ) {
                    if(resjs.getBoolean("status")){
                        JSONObject successdata  =  resjs.getJSONObject("data");
                        JSONArray result = successdata.getJSONArray("result");
                        JSONObject erpdata = (JSONObject) result.get(0);
                        erpid = erpdata.getString("id");
                    }else {

                    }

                } else {
                    sendFlag = true;
                    stringBuffer.append("接口调用失败:" + resjs.toString());
                }

            } catch (Exception e) {
                sendFlag = true;
                stringBuffer.append("接口调用失败");
            }


            //结束
            JSONObject jsonObjectData = new JSONObject();
            jsonObjectData.put("log_type", "group"); //业务类型
            jsonObjectData.put("log_status", !sendFlag);//同步状态 0同步成功 1同步失败
            jsonObjectData.put("syn_type", "0");//同步类型 0新增 1修改 2删除
            jsonObjectData.put("data_id", label);//数据id
            jsonObjectData.put("data_name", label);//数据名称
            jsonObjectData.put("mark", value);//标识
            jsonObjectData.put("mark_id", erpid);//标识
            jsonObjectData.put("res_body", "同步成功");//返回值
            jsonObjectData.put("send_url", sendUrl);//返回值
            jsonObjectData.put("send_body", sendBody);//返回值
            jsonObjectData.put("send_res", sendRes);//返回值
            if (sendFlag) {
                jsonObjectData.put("res_body", stringBuffer.toString());//返回值
            }
            // 回写
            MagicApi.saveDataLog(jsonObjectData);

        }

    }



}
