package org.ssssssss.magicboot.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.xxl.job.core.context.XxlJobHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.ssssssss.magicboot.fxapi.HttpClientResult;
import org.ssssssss.magicboot.fxapi.HttpClientUtils;
import org.ssssssss.magicboot.fxapi.XKTokenAccess;
import org.ssssssss.magicboot.fxapi.model.CrmFXApiParam;
import org.ssssssss.magicboot.zdyutils.FXHTTP;
import org.ssssssss.magicboot.zdyutils.GcjJson;
import org.ssssssss.magicboot.zdyutils.MagicApi;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/priceapprova")
public class priceapprovaController {
    static Logger log = LoggerFactory.getLogger("priceapprova");

    public static void main(String[] args) throws Exception {
            new priceapprovaController().getSynDataAdd();
            new priceapprovaController().priceapprovaSave();

    }

    public void getSynDataAdd() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        XKTokenAccess xktonken = new XKTokenAccess();
        // 查询magic接口
        //获取时间戳
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(System.currentTimeMillis() - (1000 * 60 * 60));

        String apiName = "project_quote_quotation__c";

      /*  List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("GT", "last_modified_time", System.currentTimeMillis() - (1000 * 60 * 60 * 24)),
                new CrmFXApiParam("IS", "erp_id__c", ""),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );*/


           List<CrmFXApiParam> paramList = Arrays.asList(new CrmFXApiParam("EQ", "name", "BJD-2025-05-230001"));

        JSONObject jsonject = fxapi.getSynNewDataObj(true, "项目报价询价", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");


        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String dataId = GcjJson.getNodeValue(str,  "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";

            String syn_type = "0";//同步类型 0新增 1修改 2删除
            log.info("-------------------开始执行项目报价询价" + i + " -------------------" + nameData);
            XxlJobHelper.log("-------------------开始执行项目报价询价" + i + " -------------------" + nameData);

            Boolean sendFlag = false;
            StringBuffer stringBuffer = new StringBuffer();

            try {
                boolean tbflag = false;
                //验证数据是否已存在
                JSONObject dataSyn = MagicApi.getSendSYNDatapriceapprova("priceapprova", syn_type, dataId);

                if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                    log.info("数据已存在-" + nameData);
                    XxlJobHelper.log("--数据已存在---" + nameData);
                    tbflag = true;
                }
                if (tbflag) {
                    continue;
                }
                log.info("项目报价询价申请待同步数据-" + i + " ------" + nameData);
                JSONObject jsonObjectData = new JSONObject();
                jsonObjectData.put("send_type", "priceapprova"); //业务类型
                jsonObjectData.put("send_syn", "0"); //同步类型 0新增 1修改 2删除
                jsonObjectData.put("crm_id", dataId);//数据id
                jsonObjectData.put("crmzhu_id", dataId);//数据id
                jsonObjectData.put("send_status", 3);//同步状态 true同步成功 false同步失败 3待同步
                jsonObjectData.put("crm_code", nameData);//数据名称
                jsonObjectData.put("mark", nameData);//标识
                jsonObjectData.put("crm_json", str.toJSONString());//标识

                MagicApi.saveSendSYNDatapriceapprova(jsonObjectData);
            } catch (Exception e) {
                continue;
            }

        }
    }

    public void priceapprovaSave() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
        FXHTTP fxapi = new FXHTTP();
        String resJsonStr = MagicApi.getWNRES("http://localhost:18088/syn/querypriceapprova?sendType=priceapprova&sendStatus=3&sendSyn=0", "");
        JSONObject resJson = JSON.parseObject(resJsonStr);
        if (resJson != null) {
            log.info("待同步项目报价询价申请数" + resJson.getJSONArray("data").size());
            for (int i = 0; i < resJson.getJSONArray("data").size(); i++) {

                JSONObject getData = resJson.getJSONArray("data").getJSONObject(i);
                JSONObject str = getData.getJSONObject("crmJson");
                String syn_type = "0";//同步类型 0新增 1修改 2删除
                Boolean sendFlag = false;
                StringBuffer stringBuffer = new StringBuffer();
                boolean tbflag = false;
                // 构建json

                String dataId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
                String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";

                String warranty = GcjJson.getNodeValue(str, "JSON.field_I3e77__c") != null ? GcjJson.getNodeValue(str, "JSON.field_I3e77__c").toString() : "";

                String project_location = GcjJson.getNodeValue(str, "JSON.project_location__c") != null ? GcjJson.getNodeValue(str, "JSON.project_location__c").toString() : "";
                String crspdencestd = GcjJson.getNodeValue(str, "JSON.field_h1HJx__c") != null ? GcjJson.getNodeValue(str, "JSON.field_h1HJx__c").toString() : "";

                String correspondence = GcjJson.getNodeValue(str, "JSON.field_6p1ku__c") != null ? GcjJson.getNodeValue(str, "JSON.field_6p1ku__c").toString() : "";
                String platform_manufacturer_text__c = GcjJson.getNodeValue(str, "JSON.platform_manufacturer_text__c") != null ? GcjJson.getNodeValue(str, "JSON.platform_manufacturer_text__c").toString() : "";
                String quote_requirements__c = GcjJson.getNodeValue(str, "JSON.quote_requirements__c") != null ? GcjJson.getNodeValue(str, "JSON.quote_requirements__c").toString() : "";



                String cemployeeid = "";
                if (GcjJson.getNodeValue(str, "JSON.owner__r.id") != null) {
                    cemployeeid = GcjJson.getNodeValue(str, "JSON.owner__r.id").toString();
                    cemployeeid = fxapi.getDataBYID("PersonnelObj", "_id", cemployeeid, "JSON.data.dataList[0].field_T1xid__c");
                }
           /*     if (StringUtils.isBlank(cemployeeid)) {
                    sendFlag = true;
                    stringBuffer.append("销售员不存在\n");
                }*/
                String cdeptid = "";
                if (GcjJson.getNodeValue(str, "JSON.owner_department_id") != null) {
                    String dept_id = GcjJson.getNodeValue(str, "JSON.owner_department_id").toString();
                    cdeptid = fxapi.getDataBYID("DepartmentObj", "dept_id", dept_id, "JSON.data.dataList[0].field_Vj6sf__c");
                }
                String strJson = "";
                try{
                    JSONObject dataSyn = MagicApi.getSendSYNDataquerypriceapprova("priceapprova", syn_type, dataId,"3");
                    if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                        log.info("数据已存在-" + nameData);
                        XxlJobHelper.log("--数据已存在---" + nameData);
                        tbflag = true;
                    }
                    if (tbflag) {
                        continue;
                    }




                    JSONObject params = new JSONObject();

                    JSONArray dataarr = new JSONArray();
                    JSONObject datajson = new JSONObject();
                    //编号
                    datajson.put("billno",nameData);
                    datajson.put("f9w5_crmid",dataId);
                    datajson.put("istax","0");


                    datajson.put("f9w5_billtype_number","f9w5_pmp_priceapproval_BT_XMBJ");
                    datajson.put("billcretype","3");
                    datajson.put("currency_number","CNY");
                    datajson.put("pricelisttypeid_number","JMLX_SYS_CG");
                    datajson.put("org_number","ZHY");
                    datajson.put("f9w5_warranty",warranty);
                    datajson.put("f9w5_projectlocation",project_location);
                    datajson.put("f9w5_crspdencestd",crspdencestd);
                    datajson.put("f9w5_correspondence",correspondence);


                    datajson.put("f9w5_quotereq",quote_requirements__c);//其他服务要求
                    datajson.put("f9w5_platform",platform_manufacturer_text__c);
                    String implementation_needed__c = GcjJson.getNodeValue(str, "JSON.implementation_needed__c") != null ? GcjJson.getNodeValue(str, "JSON.implementation_needed__c").toString() : "";
                    if("yes".equals(implementation_needed__c)){
                        datajson.put("f9w5_implementation","0");
                    } else if ("no".equals(implementation_needed__c)) {
                        datajson.put("f9w5_implementation","1");
                    }
                    //是否送检
                    String is_inspected__c = GcjJson.getNodeValue(str, "JSON.is_inspected__c") != null ? GcjJson.getNodeValue(str, "JSON.is_inspected__c").toString() : "";
                    if("yes".equals(is_inspected__c)){
                        datajson.put("f9w5_isinspected","0");
                    } else if ("no".equals(is_inspected__c)) {
                        datajson.put("f9w5_isinspected","1");
                    }

                    JSONArray groupstandardarr = new JSONArray();
                    JSONObject jsonjectZ = fxapi.getZDYSynDataObj("项目报价询价申请明细", "quote_details__c", "project_quote_quotation__c", dataId);
                    JSONArray arrayZ = jsonjectZ.getJSONObject("data").getJSONArray("dataList");
                    for (int j = 0; j < arrayZ.size(); j++) {
                        JSONObject stra = arrayZ.getJSONObject(j);
                        JSONObject groupstandardjson = new JSONObject();
                    //    groupstandardjson.put("priceandtax",GcjJson.getNodeValue(stra, "JSON.quote_price__c"));

                        //产品编码
                        groupstandardjson.put("material_number",GcjJson.getNodeValue(stra, "JSON.product_code_text__c"));

                        groupstandardjson.put("user_operatornumber","ID-000016");
                        groupstandardjson.put("dept_number","004");
                        //供应商编码
                       // groupstandardjson.put("supplierid_number",GcjJson.getNodeValue(stra, "JSON.supplier_code__c"));
                        groupstandardjson.put("supplierid_number","Sup-000001");

                        groupstandardjson.put("f9w5_mtdescription",GcjJson.getNodeValue(stra, "JSON.material_description__c"));
                        groupstandardjson.put("f9w5_modelnum",GcjJson.getNodeValue(stra, "JSON.specification_model__c"));

                        groupstandardjson.put("f9w5_crmentryid",GcjJson.getNodeValue(stra, "JSON._id"));

                   //     groupstandardjson.put("taxrateid_number","V13");
                     //   groupstandardjson.put("invoicetype",GcjJson.getNodeValue(stra, "JSON.invoice_type__c"));
                   //     groupstandardjson.put("settlementtype",GcjJson.getNodeValue(stra, "JSON.payment_method__c"));

                        groupstandardarr.add(groupstandardjson);

                    }

                    datajson.put("priceentryentity",groupstandardarr);//明细
                    dataarr.add(datajson);
                    params.put("data",dataarr);
                    log.info("--请求json---" + params.toJSONString());
                    System.out.println("--请求json:---" +params.toJSONString());
                    strJson = params.toJSONString();

                }catch  (Exception e) {
                    sendFlag = true;
                    stringBuffer.append("参数解析错误，请联系开发人员");
                    e.printStackTrace();
                }
                getSynDataSave(stringBuffer,sendFlag,fxapi,dataId,nameData,strJson,getData);

            }
        }
    }
    /**
     * 写数据
     */
    public void getSynDataSave(StringBuffer stringBuffer,Boolean sendFlag,FXHTTP fxapi,String dataId,String nameData,String obj,JSONObject str) {
        String syn_type = "0";//同步类型 0新增 1修改 2删除
        String res_url = "http://192.168.31.233:8022/ierp/kapi/v2/f9w5/pmp/f9w5_pmp_priceapproval/priceapprovalSave";
        String res_param = obj;
        String res = "";
        try {
          //  String accessToken = "2095345516136108032_XQmekTd9H2mWOICLK86jt4bMzjP53Bm4KrspyFaPG790rSA6k3CdpwJ9fSx9RiBhK63rKELG7oIyLPdeNgpXu47zRh6Ndnud9jf009";
            String accessToken = new KDTokenController().getKDAccessTokenTest();


            Map<String, String> headers = new HashMap<String, String>();
            headers.put("accessToken",  accessToken);//放token
            HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, obj);
            String resStr =  rtn.getContent();
            JSONObject resjs = JSONObject.parseObject(resStr);
            res = resStr;
            if (resjs != null && resjs.getBoolean("status")) {
                JSONObject successdata  =  resjs.getJSONObject("data");
                JSONArray result = successdata.getJSONArray("result");
                JSONObject erpdata = (JSONObject) result.get(0);
                String erpid = erpdata.getString("id");

                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("erp_id__c", erpid);//数据ID
                paramMap.put("sync_status__c", "option_sync_success__c");
                paramMap.put("sync_info__c", resjs.getString("message"));
                //回写json
                fxapi.upSynZDYFieldParam("", "project_quote_quotation__c", dataId, paramMap);
            }else{
                sendFlag=true;
                stringBuffer.append("项目报价询价申请创建接口调用失败:"+resjs.getString("message"));
                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("sync_status__c", "option_sync_failure__c");
                paramMap.put("sync_info__c", stringBuffer);
                //回写json
                fxapi.upSynZDYFieldParam("", "project_quote_quotation__c", dataId, paramMap);
            }
        } catch (Exception e) {
            sendFlag = true;
            stringBuffer.append("项目报价询价申请创建接口调用失败,请检查网络配置");
            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("sync_status__c", "option_sync_failure__c");
            paramMap.put("sync_info__c", stringBuffer);
            //回写json
            fxapi.upSynFieldParam("", "project_quote_quotation__c", dataId, paramMap);
        }

        JSONObject sendData = new JSONObject();

        sendData.put("send_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步

        sendData.put("send_id", str.getString("sendId")); //send_id
        MagicApi.updateSendSYUPDATEpriceapprova(sendData);

        JSONObject logData = new JSONObject();
        logData.put("log_type", "priceapprova"); //业务类型
        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
        logData.put("data_id", dataId);//数据id
        logData.put("data_name", nameData);//数据名称
        logData.put("res_body", "同步成功");//返回值
        logData.put("res_url", res_url);//
        logData.put("res_param", res_param);//
        logData.put("res_res", res);//
        if (sendFlag) {
            logData.put("res_body", stringBuffer.toString());//返回值
        }
        //写入传输日志
        MagicApi.savesavepriceapprovaLog(logData);
    }



}
