package org.ssssssss.magicboot.zdyutils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.xxl.job.core.context.XxlJobHelper;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.ssssssss.magicboot.fxapi.XKTokenAccess;
import org.ssssssss.magicboot.fxapi.model.CrmFXApiParam;
import org.ssssssss.magicboot.zdyutils.APIUtil;
import org.ssssssss.magicboot.zdyutils.FXTIC;
import org.ssssssss.magicboot.zdyutils.GcjJson;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.TimeZone;

public class FXHTTP {
    private final Logger log = LoggerFactory.getLogger(FXHTTP.class);
    /**
     * 插入信息 V2
     *
     * @param Xkjson
     */
    public String saveV2ZDYObj(JSONObject Xkjson) {
        String url = "https://open.fxiaoke.com/cgi/crm/custom/v2/data/create";
        return APIUtil.FXApiObj(url, Xkjson.toJSONString());
    }
    public String saveV2BOM(JSONObject Xkjson) {
        String url = "https://open.fxiaoke.com/cgi/crm/v2/special/bom/saveBomTree";
        return APIUtil.FXApiObj(url, Xkjson.toJSONString());
    }
    /**
     * 修改同步字段
     *
     * @param id
     * @param state 未同步  已同步   同步失败
     * @param code  金蝶编码
     */
    public String invalid(Boolean urlFlag,String methodName, String apiName,  String id) {
        JSONObject jsonObject = new JSONObject();

        XKTokenAccess xktonken = new XKTokenAccess();
        String saveJSON = "{\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\",\n" +
                "\t\"data\": {\n" +
                "\t\t\t\"dataObjectApiName\": \"" + apiName + "\",\n" +
                "\t\t\t\"object_data_id\": \"" + id + "\",\n" +
                "\t}\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/invalid";
        if(urlFlag){
            url = "https://open.fxiaoke.com/cgi/crm/custom/v2/data/invalid";
        }
        System.out.println(methodName+"-作废"+saveJSON);
        JSONObject SAVEJSON = JSON.parseObject(saveJSON);
        //请求接口
        String result=  APIUtil.FXApiObj(url, SAVEJSON.toString());
        System.out.println(methodName+"-作废返回"+result);
        return result;
    }
    /**
     * 插入信息 V2
     *
     * @param Xkjson
     */
    public String updateV2ZDYObj(JSONObject Xkjson) {
        String url = "https://open.fxiaoke.com/cgi/crm/custom/v2/data/update";
        return APIUtil.FXApiObj(url, Xkjson.toJSONString());
    }

    /**
     * 插入信息 V2
     *
     * @param Xkjson
     */
    public String saveV2Obj(JSONObject Xkjson) {
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/create";
        return APIUtil.FXApiObj(url, Xkjson.toJSONString());
    }

    /**
     * 插入信息 V2
     *
     * @param Xkjson
     */
    public String updateV2Obj(JSONObject Xkjson) {
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/update";
        return APIUtil.FXApiObj(url, Xkjson.toJSONString());
    }
    /**
     * 查询未同步的纷享信息
     */
    public JSONObject getQueryProductCategory(String methodName) {
        log.info(methodName + "-查询未同步的纷享信息 ");
        XKTokenAccess xktonken = new XKTokenAccess();
        //获取时间戳
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t},\n" +
                "      \"corpId\": \"" + xktonken.getCorpAccessToken().getCorpId() + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/data/queryProductCategory";
        log.info(methodName + "-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        log.info(methodName + "-请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }
    /**
     * 查详情
     */
    public JSONObject getSynDataGetObj(String methodName, String apiName, String id) {
        XKTokenAccess xktonken = new XKTokenAccess();
        //获取时间戳
        String saveJSON = "{\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\",\n" +
                "\t\"data\": {\n" +
                "\t\t\t\"dataObjectApiName\": \"" + apiName + "\",\n" +
                "\t\t\t\"objectDataId\": \"" + id + "\"\n" +
                "\t}\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/get";
        String jsonStr = APIUtil.FXApiObj(url, saveJSON);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }

    /**
     * 自定义详情
     */
    public JSONObject getSynDataZDYGetObj(String methodName, String apiName, String id) {
        XKTokenAccess xktonken = new XKTokenAccess();
        //获取时间戳
        String saveJSON = "{\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\",\n" +
                "\t\"data\": {\n" +
                "\t\t\t\"dataObjectApiName\": \"" + apiName + "\",\n" +
                "\t\t\t\"objectDataId\": \"" + id + "\"\n" +
                "\t}\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/custom/v2/data/get";
        String jsonStr = APIUtil.FXApiObj(url, saveJSON);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }

    /**
     * 查询未同步的纷享信息
     */
    public String getDataBYKH(String apiName, String fieldName, String fieldValue, String jsonPath) {
        XKTokenAccess xktonken = new XKTokenAccess();
        String str = null;
        //获取时间戳
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 20,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"isAsc\": false\n" +
                "\t\t\t}],\n" +
//                "\t\t\t\"fieldProjection\": [\"life_status\"],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldName + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldValue + "\"]\n" +
                "\t\t\t}]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/query";
        System.out.println("-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println("-请求json-" + SAVEJSON);

        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);

        if (SAVEJSON1 != null && "0".equals(SAVEJSON1.getString("errorCode"))) {
            try {
                str = (String) GcjJson.getNodeValue(SAVEJSON1, jsonPath);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return str;
    }

    /**
     * 查询未同步的纷享信息
     */
    public String getDataBYKHID(String apiName, String fieldName, String fieldValue, String fieldName2, String fieldValue2, String jsonPath) {
        XKTokenAccess xktonken = new XKTokenAccess();
        String str = null;
        //获取时间戳
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 20,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"isAsc\": false\n" +
                "\t\t\t}],\n" +
//                "\t\t\t\"fieldProjection\": [\"life_status\"],\n" +
                "\t\t\t\"filters\": [" +
                "{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldName + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldValue + "\"]\n" +
                "\t\t\t}," +
                "{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldValue2 + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldName2 + "\"]\n" +
                "\t\t\t}" +
                "]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/query";
        System.out.println("-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println("-请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);

        if (SAVEJSON1 != null && "0".equals(SAVEJSON1.getString("errorCode"))) {
            try {
                str = (String) GcjJson.getNodeValue(SAVEJSON1, jsonPath);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return str;
    }

    /**
     * 查询未同步的纷享信息
     */
    public String getDataBYID(String apiName, String fieldName, String fieldValue, String jsonPath) {
        try {
            Thread.sleep(100);
        } catch (Exception e) {
            e.printStackTrace();
        }
        XKTokenAccess xktonken = new XKTokenAccess();
        String str = null;
        //获取时间戳
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 20,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"isAsc\": false\n" +
                "\t\t\t}],\n" +
//                "\t\t\t\"fieldProjection\": [\"life_status\"],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldName + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldValue + "\"]\n" +
                "\t\t\t}]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/query";
        System.out.println("-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println("-请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);

        if (SAVEJSON1 != null && "0".equals(SAVEJSON1.getString("errorCode"))) {
            try {
                if (StringUtils.isNoneBlank(jsonPath)) {
                    if(SAVEJSON1.getJSONObject("data")!=null && SAVEJSON1.getJSONObject("data").getInteger("total")<1){
                        return (String) GcjJson.getNodeValue(SAVEJSON1, jsonPath);
                    }
                    return GcjJson.getNodeValue(SAVEJSON1, jsonPath).toString();
                }
                return SAVEJSON1.toJSONString();


            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return str;
    }

    /**
     * 查询未同步的纷享信息
     */
    public String getDataDYHS(JSONObject Xkjson) {
        String str = "";
        //获取时间戳
        String url = "https://open.fxiaoke.com/cgi/crm/v2/special/function";
        System.out.println("-请求url-" + url);
        System.out.println("-请求json-" + Xkjson);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson.toJSONString());
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);

        if (SAVEJSON1 != null && "1".equals(SAVEJSON1.getJSONObject("data").getString("code"))) {
            try {
                str = SAVEJSON1.getJSONObject("data").getJSONObject("data").toJSONString();
            } catch (Exception e) {
                e.printStackTrace();
                return null;
            }
        }
        return str;
    }

    /**
     * 查询未同步的纷享信息
     */
    public JSONObject getDataBYIDRES(String apiName, String fieldName, String fieldValue, String jsonPath) {
        XKTokenAccess xktonken = new XKTokenAccess();
        JSONObject str = null;
        //获取时间戳
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 20,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"isAsc\": false\n" +
                "\t\t\t}],\n" +
//                "\t\t\t\"fieldProjection\": [\"life_status\"],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldName + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldValue + "\"]\n" +
                "\t\t\t}]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/query";
        System.out.println("-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println("-请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);

        if (SAVEJSON1 != null && "0".equals(SAVEJSON1.getString("errorCode"))) {
            try {
                return SAVEJSON1;
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return str;
    }

    /**
     * 查询未同步的纷享信息
     */
    public String getDataZDYBYID(String apiName, String fieldName, String fieldValue, String jsonPath) {
        XKTokenAccess xktonken = new XKTokenAccess();
        String str = null;
        //获取时间戳
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 20,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"isAsc\": false\n" +
                "\t\t\t}],\n" +
//                "\t\t\t\"fieldProjection\": [\"life_status\"],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldName + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldValue + "\"]\n" +
                "\t\t\t}]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/custom/v2/data/query";
        System.out.println("-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println("-请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);

        if (SAVEJSON1 != null && "0".equals(SAVEJSON1.getString("errorCode"))) {
            try {
                if (StringUtils.isNoneBlank(jsonPath)) {
                    if(SAVEJSON1.getJSONObject("data")!=null && SAVEJSON1.getJSONObject("data").getInteger("total")<1){
                        return (String) GcjJson.getNodeValue(SAVEJSON1, jsonPath);
                    }
                    return GcjJson.getNodeValue(SAVEJSON1, jsonPath).toString();
                }
                return SAVEJSON1.toJSONString();


            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return str;
    }

//    public static void main(String[] args) {
//        List<CrmFXApiParam> paramList = Arrays.asList(
//                new CrmFXApiParam("=", "id", "123"),
//                new CrmFXApiParam("!=", "name", "张三")
//        );
//        new FXHTTP().getSynNewDataObj(false,"","",paramList);
//    }
    /**
     * 查询未同步的纷享信息
     */
    public JSONObject getSynNewDataObj(Boolean urlFlag,String methodName, String apiName, List<CrmFXApiParam> CrmFXApiParam) {
        System.out.println(methodName + "-查询未同步的纷享信息 ");
        XKTokenAccess xktonken = new XKTokenAccess();
        // 构建json
        JSONObject obj = new JSONObject();
        LinkedHashMap map = new LinkedHashMap<String, Object>();
        map.put("body.corpId", FXTIC.CORPID);
        map.put("body.corpAccessToken", xktonken.getCorpAccessToken().getCorpAccessToken());
        map.put("body.currentOpenUserId", FXTIC.CURRENTOPENUSERID);

        map.put("body.data.search_query_info.offset", 0);
        map.put("body.data.search_query_info.limit", 999);
        map.put("body.data.search_query_info.orders[0].fieldName", "create_time");
        map.put("body.data.search_query_info.orders[0].isAsc", "true");
        for (int i = 0; i < CrmFXApiParam.size(); i++) {
            map.put("body.data.search_query_info.filters["+i+"].operator", CrmFXApiParam.get(i).getOperator());
            map.put("body.data.search_query_info.filters["+i+"].field_name", CrmFXApiParam.get(i).getFieldKey());
            map.put("body.data.search_query_info.filters["+i+"].field_values", CrmFXApiParam.get(i).getFieldValue());
        }
        map.put("body.data.dataObjectApiName", apiName);

        try {
            for (Object key : map.keySet()) {
                GcjJson.setNodeValue(obj, key.toString(), map.get(key));
            }
        } catch (Exception e) {

        }

        System.out.println(obj);
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/query";
        if(urlFlag){
            url = "https://open.fxiaoke.com/cgi/crm/custom/v2/data/query";
        }
        System.out.println(methodName + "-请求url-" + url);
        System.out.println(methodName + "-请求json-" + obj.toJSONString());
        String  jsonStr=  APIUtil.FXApiObj(url,obj.toJSONString());
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }

    /**
     * 查询未同步的纷享信息
     */
    public JSONObject getSynDataObj(String methodName, String apiName, String fieldName, String fieldValue) {
        System.out.println(methodName + "-查询未同步的纷享信息 ");
        XKTokenAccess xktonken = new XKTokenAccess();
        //获取时间戳
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 999,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"fieldName\": \"create_time\",\n" +
                "\t\t\t\t\"isAsc\": true\n" +
                "\t\t\t}],\n" +
//                "\t\t\t\"fieldProjection\": [\"life_status\"],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldName + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldValue + "\"]\n" +
                "\t\t\t},{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"life_status\",\n" +
                "\t\t\t\t\"field_values\": [\"normal\"]\n" +
                "\t\t\t}]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/query";
        System.out.println(methodName + "-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println(methodName + "-请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }
    /**
     * 查询未同步的纷享信息
     */
    public JSONObject getSynDataZDYObj(String methodName, String apiName, String fieldName, String fieldValue) {
        //System.out.println(methodName + "-查询未同步的纷享信息 ");
        XKTokenAccess xktonken = new XKTokenAccess();
        //获取时间戳
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 999,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"fieldName\": \"create_time\",\n" +
                "\t\t\t\t\"isAsc\": true\n" +
                "\t\t\t}],\n" +
//                "\t\t\t\"fieldProjection\": [\"life_status\"],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldName + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldValue + "\"]\n" +
                "\t\t\t}]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/custom/v2/data/query";
         System.out.println(methodName + "-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println(methodName + "-请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }
    /**
     * 获取销客对象描述
     */
    //apiNmae+id
    public JSONObject getXKName(String apiNmae) {
        XKTokenAccess xktonken = new XKTokenAccess();
        String Xkjson = "{\n" +
                "    \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"apiName\": \"" + apiNmae + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        System.out.println(Xkjson);

        String jsonStr = APIUtil.FXApiObj(FXTIC.URL_DESCRIBE, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }

    /**
     * 查询未同步的纷享信息
     */
    public JSONObject getSynDataOrderObj(String methodName, String apiName, String fieldName, String fieldValue) {
        System.out.println(methodName + "-查询未同步的纷享信息 ");
        XKTokenAccess xktonken = new XKTokenAccess();
        long current = System.currentTimeMillis();
        long daytime2 = current - (current + TimeZone.getDefault().getRawOffset()) % (1000 * 3600 * 3);
        //获取时间戳
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 999,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"fieldName\": \"create_time\",\n" +
                "\t\t\t\t\"isAsc\": true\n" +
                "\t\t\t}],\n" +
//                "\t\t\t\"fieldProjection\": [\"life_status\"],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldName + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldValue + "\"]\n" +
                "\t\t\t}" +
                "{\n" +
                "\t\t\t\t\"operator\": \"GT\",\n" +
                "\t\t\t\t\"field_name\": \"last_modified_time\",\n" +
                "\t\t\t\t\"field_values\": [\"" + daytime2 + "\"]\n" +
                "\t\t\t}\n" +
                "]\n" +

                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/query";
        System.out.println(methodName + "-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println(methodName + "-请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);


        return SAVEJSON1;
    }

    /**
     * 查询未同步的纷享信息
     */
    public JSONObject getSynDataDateObj(String methodName, String apiName, String fieldName, String fieldValue) {
        System.out.println(methodName + "-查询未同步的纷享信息 ");
        XKTokenAccess xktonken = new XKTokenAccess();
        //获取时间戳
        long current = System.currentTimeMillis();
        long daytime2 = current - (1000 * 3600 * 1);
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 20,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"fieldName\": \"create_time\",\n" +
                "\t\t\t\t\"isAsc\": true\n" +
                "\t\t\t}],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"GT\",\n" +
                "\t\t\t\t\"field_name\": \"last_modified_time\",\n" +
                "\t\t\t\t\"field_values\": [\"" + daytime2 + "\"]\n" +
                "\t\t\t}]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/query";
        System.out.println(methodName + "-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println(methodName + "-请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }

    public JSONObject getCrmFileData(String crmId) {

        XKTokenAccess xktonken = new XKTokenAccess();

        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"postId\": \""+ crmId +"\",\n" +
                "\t\t\"api_name\": \"CstmCtrl_n4Bw6__c\",\n" +
                "\t\t\t\"parameters\": [{\n" +
                "\t\t\t\t\"name\": \"crmId\",\n" +
                "\t\t\t\t\"type\": \"String\",\n" +
                "\t\t\t\t\"value\": \"" + crmId + "\"\n" +
                "\t\t\t}]\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/special/function";
        System.out.println("-附件查询请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println("-附件查询请求json-" + SAVEJSON);
        String jsonStr = APIUtil.FXApiObj(url, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }


    /**
     * 查询未同步的纷享信息
     */
    public JSONObject getSynDataZDYDateObj(String methodName, String apiName, String fieldName, String fieldValue) {
        System.out.println(methodName + "-查询未同步的纷享信息 ");
        XKTokenAccess xktonken = new XKTokenAccess();
        //获取时间戳
        long current = System.currentTimeMillis();
        long daytime2 = current - (current + TimeZone.getDefault().getRawOffset()) % (1000 * 3600 * 4);
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 999,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"fieldName\": \"create_time\",\n" +
                "\t\t\t\t\"isAsc\": true\n" +
                "\t\t\t}],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"GT\",\n" +
                "\t\t\t\t\"field_name\": \"last_modified_time\",\n" +
                "\t\t\t\t\"field_values\": [\"" + daytime2 + "\"]\n" +
                "\t\t\t}]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        System.out.println(methodName + "-请求url-" + FXTIC.URL_FX_ZDYQUERY);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println(methodName + "-请求json-" + SAVEJSON);

        String jsonStr = APIUtil.FXApiObj(FXTIC.URL_FX_ZDYQUERY, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }

    /**
     * 查询未同步的纷享信息
     */
    public JSONObject getZDYSynDataObj(String methodName, String apiName, String fieldName, String fieldValue) {
        System.out.println(methodName + "-查询未同步的纷享信息 ");
        XKTokenAccess xktonken = new XKTokenAccess();
        String Xkjson = "{\n" +
                "\t\n" +
                "\t\"data\": {\n" +
                "\t\t\"search_query_info\": {\n" +
                "\t\t\t\"offset\": 0,\n" +
                "\t\t\t\"limit\": 20,\n" +
                "\t\t\t\"orders\": [{\n" +
                "\t\t\t\t\"isAsc\": false\n" +
                "\t\t\t}],\n" +
//                "\t\t\t\"fieldProjection\": [\"life_status\"],\n" +
                "\t\t\t\"filters\": [{\n" +
                "\t\t\t\t\"operator\": \"EQ\",\n" +
                "\t\t\t\t\"field_name\": \"" + fieldName + "\",\n" +
                "\t\t\t\t\"field_values\": [\"" + fieldValue + "\"]\n" +
                "\t\t\t}]\n" +
                "\t\t},\n" +
                "\t\t\"dataObjectApiName\": \"" + apiName + "\"\n" +
                "\t},\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/query";
        System.out.println(methodName + "-请求url-" + url);
        JSONObject SAVEJSON = JSON.parseObject(Xkjson);
        System.out.println(methodName + "-请求json-" + SAVEJSON);

        String jsonStr = APIUtil.FXApiObj(FXTIC.URL_FX_ZDYQUERY, Xkjson);
        JSONObject SAVEJSON1 = JSON.parseObject(jsonStr);
        return SAVEJSON1;
    }

    /**
     * 修改同步字段
     *
     * @param id
     * @param state 未同步  已同步   同步失败
     * @param code  金蝶编码
     */
    public void upSynField(String methodName, String apiName, String fieldName, String id, String state) {
        System.out.println(methodName + "-修改同步字段 ");
        JSONObject jsonObject = new JSONObject();

        XKTokenAccess xktonken = new XKTokenAccess();
        String saveJSON = "{\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\",\n" +
                "\t\"data\": {\n" +
                "\t\t\"object_data\": {\n" +
                "\t\t\t\"dataObjectApiName\": \"" + apiName + "\",\n" +
                "\t\t\t\"_id\": \"" + id + "\",\n" +
                "\t\t\t\"" + fieldName + "\": \"" + state + "\"\n" +
                "\t\t}\n" +
                "\t}\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/data/update";
        System.out.println(saveJSON);
        JSONObject SAVEJSON = JSON.parseObject(saveJSON);
        //请求接口
        APIUtil.FXApiObj(FXTIC.URL_FX_UPDATE, SAVEJSON.toString());
    }

    /**
     * 修改订单明细
     */
    public void upSynDDFieldParam(String methodName, String apiName, String id, Map<String, Object> paramMap) {
        XKTokenAccess xktonken = new XKTokenAccess();
        String saveJSON = "{\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\",\n" +
                "\t\"data\": {\n" +
                "\t\t\"object_data\": {\n" +
                "\t\t\t\"dataObjectApiName\": \"" + apiName + "\",\n" +
                "\t\t\t\"_id\": \"" + id + "\"\n" +
                "\t\t}\n" +
                "\t}\n" +
                "}";

        JSONObject SAVEJSON = JSON.parseObject(saveJSON);
        for (String key : paramMap.keySet()) {
            SAVEJSON.getJSONObject("data").getJSONObject("object_data").put(key, paramMap.get(key));
        }
        System.out.println("修改json" + SAVEJSON);

        //请求接口
        APIUtil.FXApiObj(FXTIC.URL_FX_UPDATE, SAVEJSON.toString());
    }

    /**
     * 修改同步字段
     *
     * @param id
     * @param state 未同步  已同步   同步失败
     * @param code  金蝶编码
     */
    public void upSynFieldParam(String methodName, String apiName, String id, Map<String, Object> paramMap) {
        XKTokenAccess xktonken = new XKTokenAccess();
        String saveJSON = "{\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\",\n" +
                "    \"triggerWorkFlow\": false,\n" +
                "    \"triggerApprovalFlow\": false,\n" +
                "\t\"data\": {\n" +
                "\t\t\"object_data\": {\n" +
                "\t\t\t\"dataObjectApiName\": \"" + apiName + "\",\n" +
                "\t\t\t\"_id\": \"" + id + "\"\n" +
                "\t\t}\n" +
                "\t}\n" +
                "}";

        JSONObject SAVEJSON = JSON.parseObject(saveJSON);
        for (String key : paramMap.keySet()) {
            SAVEJSON.getJSONObject("data").getJSONObject("object_data").put(key, paramMap.get(key));
        }
        System.out.println("修改json" + SAVEJSON);
        XxlJobHelper.log( "--修改json---"+ SAVEJSON);
        log.info( "--修改json---"+ SAVEJSON);
        //请求接口

        String strss= APIUtil.FXApiObj(FXTIC.URL_FX_UPDATE, SAVEJSON.toString());
        log.info("修改" + strss);
    }

    public void upSynFieldParamcdx(String methodName, String apiName, String id, Map<String, Object> paramMap, Map<String, Object> paramMapcdx) {
        XKTokenAccess xktonken = new XKTokenAccess();
        String saveJSON = "{\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\",\n" +
                "    \"triggerWorkFlow\": false,\n" +
                "    \"triggerApprovalFlow\": false,\n" +
                "\t\"data\": {\n" +
                "\t\t\"object_data\": {\n" +
                "\t\t\t\"dataObjectApiName\": \"" + apiName + "\",\n" +
                "\t\t\t\"_id\": \"" + id + "\"\n" +
                "\t\t},\n" +
                "\t\t\"details\": {\n" +
                "\t\t}\n" +
                "\t}\n" +
                "}";

        JSONObject SAVEJSON = JSON.parseObject(saveJSON);
        for (String key : paramMap.keySet()) {
            SAVEJSON.getJSONObject("data").getJSONObject("object_data").put(key, paramMap.get(key));
        }

        for (String key : paramMapcdx.keySet()) {
            SAVEJSON.getJSONObject("data").getJSONObject("details").put(key, paramMapcdx.get(key));
        }
        System.out.println("修改json" + SAVEJSON);
        XxlJobHelper.log( "--修改json---"+ SAVEJSON);
        log.info( "--修改json---"+ SAVEJSON);
        //请求接口

        String strss= APIUtil.FXApiObj(FXTIC.URL_FX_UPDATE, SAVEJSON.toString());
        log.info("修改" + strss);
    }

    /**
     * 解锁
     *
     * @param id
     * @param state 未同步  已同步   同步失败
     * @param code  金蝶编码
     */
    public void lock(boolean state, String id, String apiName) {
        XKTokenAccess xktonken = new XKTokenAccess();

        String Xkjson = "{\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\",\n" +

                "    \"data\":{\n" +
                "      \n" +
                "            \"dataObjectApiName\":\"" + apiName + "\",\n" +
                "             \"dataIds\": [\n" +
                "            \"" + id + "\"\n" +
                "        ],\n" +
                "        \"detailObjStrategy\": 1\n" +
                "     \n" +
                "    }\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/crm/v2/object/unlock";
        if (state) {
            url = "https://open.fxiaoke.com/cgi/crm/v2/object/lock";
        }
        //请求接口
        APIUtil.FXApiObj(url, Xkjson);
    }

    /**
     * 修改同步字段-成功
     *
     * @param id
     * @param state 未同步  已同步   同步失败
     * @param code  金蝶编码
     */
    public void upSynZDYFieldParam(String methodName, String apiName, String id, Map<String, Object> paramMap) {
        XKTokenAccess xktonken = new XKTokenAccess();
        String saveJSON = "{\n" +
                "      \"corpId\": \"" + FXTIC.CORPID + "\",\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"currentOpenUserId\": \"" + FXTIC.CURRENTOPENUSERID + "\",\n" +
                "    \"triggerWorkFlow\": false,\n" +
                "    \"triggerApprovalFlow\": false,\n" +
                "\t\"data\": {\n" +
                "\t\t\"object_data\": {\n" +
                "\t\t\t\"dataObjectApiName\": \"" + apiName + "\",\n" +

                "\t\t\t\"_id\": \"" + id + "\"\n" +
                "\t\t}\n" +
                "\t}\n" +
                "}";

        JSONObject SAVEJSON = JSON.parseObject(saveJSON);
        for (String key : paramMap.keySet()) {
            SAVEJSON.getJSONObject("data").getJSONObject("object_data").put(key, paramMap.get(key));
        }
        System.out.println("zdyxiuga" + SAVEJSON);
        //请求接口
        APIUtil.FXApiObj(FXTIC.URL_FX_ZDYUP, SAVEJSON.toString());
    }

    public static void main(String[] args) {
        new FXHTTP().sendMsg("1000", "失败原因，失败原因，失败原因，失败原因", "6422818e32c0df0001c842ab", "客户同步异常", "AccountObj");
    }

    //发送用户信息
    public void sendMsg(String userID, String content, String dataId, String title, String objDescApiName) {
        System.out.println(("发送用户信息" + userID + "内容=" + content));
        if (content != null && content.equals("订单产品编号必填-1054")) {
            content = "纷享销售订单未创建，请先创建销售订单";
        }
        content = content.replaceAll("\"", "\\\\\"");
        XKTokenAccess xktonken = new XKTokenAccess();

        String Xkjson = "{\n" +
                "    \"corpAccessToken\": \"" + xktonken.getCorpAccessToken().getCorpAccessToken() + "\",\n" +
                "    \"corpId\":\"" + xktonken.getCorpAccessToken().getCorpId() + "\",\n" +
                "\n" +
                "    \"toUser\":[\n" +
                "      \"" + userID + "\",\n" +
                "      \"" + FXTIC.CURRENTOPENUSERID + "\"\n" +
                "    ],\n" +
                "    \"msgType\":\"composite\",\n" +
                "    \"composite\":{\n" +
                "        \"head\":{\n" +
                "            \"title\":\"" + title + "\"\n" +
                "        },\n" +
                "        \"first\":{\n" +
                "            \"content\":\"失败原因\"\n" +
                "        },\n" +
                "        \"form\":[\n" +
                "        ],\n" +
                "        \"remark\":{\n" +
                "            \"content\":\"" + content + "\"\n" +
                "        },\n" +
                "        \"link\":{\n" +
                "            \"title\":\"详情\",\n" +
                "            \"url\":\"fs://CRM/udobj?{\\\"objDescApiName\\\":\\\"" + objDescApiName + "\\\",\\\"objDataId\\\":\\\"" + dataId + "\\\"}\"\n" +
                "        }\n" +
                "    }\n" +
                "}";
        String url = "https://open.fxiaoke.com/cgi/message/send";
        //请求接口
        APIUtil.FXApiObj(url, Xkjson);

    }


}
